extproc sh
#!sh
# 
# os2unix version 1.02 by Jun SAWATAISHI <jsawa@attglobal.net>
#
# 
#   Purpose: Rewrite scripts (configure ...) and Makefile.in's 
#            to run configure and make WITHOUT AUTOCONF. 
# 
#            At least you will succeed in 9 of 10. 
#
#   Usage: 
#          In a top source directory
# 
#            x:/source/foo> os2unix -all
#            x:/source/foo> sh configure --help
#            x:/source/foo> sh configure [SOME_ARGUMENT]
#            x:/source/foo> make
#            x:/source/foo> make install prefix=XXX
#           
#
# @@@ Required Executables @@@
#
#   HOBBES=ftp://hobbes.nmsu.edu/pub/os2
#   LEO=ftp://ftp.leo.org/pub/comp/os/os2/leo
#   JSAWA=http://www2s.biglobe.ne.jp/~vtgf3mpr
#
#  GNU find (find.exe)
#      LEO/gnu/systools/gnufind.zip   ; v4.1
#      HOBBES/util/disk/gnufind.zip   ; v4.1
#  GNU sed 
#      LEO/gnu/systools/gnused.zip    ; v2.05
#      HOBBES/apps/editors/gnused.zip ; v3.0
#      JSAWA/gnu/sed.hgm              ; v3.02.80
#  GNU grep (grep.exe)
#      HOBBES/util/file/gnugrep.zip    ; v2.0
#      LEO/gnu/systools/gnugrep.zip    ; v2.0 
#      JSAWA/gnu/grep.htm              ; v2.3h or later
#  
#  file - determine file type          ; v3.30
#      JSAWA/os2unix/file330.zip
#
# Note for web2c source
#       etexdir/etex.mk: change PATH sep ':' to '\;'
#   pdftexdir/pdftex.mk
#         Change pdftexdir/pdftosrc.o:$(srcdir)/pdftexdir/pdftosrc.c
#             to pdftexdir/pdftosrc.o: $(srcdir)/pdftexdir/pdftosrc.c
# 
#
#@@@ You must define SC_DIR @@@
#
#SC_DIR="i:/RedHat/SOURCES"
SC_DIR="os2"
#@@@ user definetions @@@

SED_CONF="${SC_DIR}/os2_convert_configure.sed"
SED_MK="${SC_DIR}/os2_convert_Makefile_in.sed"
SED_MK2="${SC_DIR}/os2_convert_mk.sed"
SED_PO_MK="${SC_DIR}/os2_convert_Makefile_in_in.sed"
MKSINSTALLDIRS="${SC_DIR}/os2_mkinstalldirs"

## functions

function ch_script
{
	  if [ ! -f 00cp_script.tmp ] ; then
	    find . -type f -regex '.*/[^/.]+' ! -name configure ! \
	      -name mkinstalldirs -exec file '{}' \; \
	    | grep script |cut -d: -f1 | sed 's@^\(.*\)$@cp.exe -uvp \1 \1.orig@' \
	           > 00cp_script.tmp
	     cat ./00cp_script.tmp
	     sh ./00cp_script.tmp
	  fi
	    sed 's_^cp.exe \-uvp \(.*\) \(.*\)$_sed s@\/bin\/sh@sh@ \2 > \1_' \
	       00cp_script.tmp > 00convert_script.tmp
		cat 00convert_script.tmp
	    sh ./00convert_script.tmp

}

function ch_config
{ 
		if [ ! -f CONFIGURE_CHANGED.tmp ] ; then
			find . -name configure -exec cp '{}' '{}'.orig \; 
			touch CONFIGURE_CHANGED.tmp
		fi
		find . -name configure -exec "sed -f ${SED_CONF} {}.orig > {}" \; 
		find . -name 'configure' -o -name 'configure.orig' 
}
function ch_makefile
{
		if [ ! -f MAKEFILE_in_CHANGED.tmp ] ; then
			find . -name Makefile.in  -exec cp '{}' '{}'.orig \;
			touch MAKEFILE_in_CHANGED.tmp
		fi
		find . -name Makefile.in  -exec "sed -f ${SED_MK} {}.orig > {}" \;
		find . -name 'Makefile.in*'
}
function ch_po_makefile
{
		if [ ! -f MAKEFILE_in_in_CHANGED.tmp ] ; then
			find . -name Makefile.in.in  -exec cp '{}' '{}'.orig \;
			touch MAKEFILE_in_in_CHANGED.tmp
		fi
		find . -name Makefile.in.in  -exec "sed -f ${SED_PO_MK} {}.orig > {}" \;
		find . -name 'Makefile.in.in'
}

function mkdirs
{
		if [ ! -f MKIN.tmp ] ; then
	      find . -name mkinstalldirs  -exec cp ${MKSINSTALLDIRS} '{}'  \;
		  find . -name mkinstalldirs -print
		fi
		touch MKIN.tmp

}


function web2c_mk
{
		if [ ! -f MK_CHANGED.tmp ] ; then
			find . -name '*.mk'  -exec cp '{}' '{}'.orig \;
			touch MK_CHANGED.tmp
		fi
		find . -name '*.mk'  -exec "sed -f ${SED_MK2} {}.orig > {}" \;
		find . -name '*.mk**'
}

function web2c_make
{
		if [ ! -f MAKE_CHANGED.tmp ] ; then
			find . -name '*.make'  -exec cp '{}' '{}'.orig \;
			touch MAKE_CHANGED.tmp
		fi
		find . -name '*.make'  -exec "sed -f ${SED_MK2} {}.orig > {}" \;
		find . -name '*.make**'
}

## functions


if [ ! -f $SED_CONF ] ; then
  echo "@@Cannnot execute, because $SED_CONF not exist"
  exit 1
fi

if [ ! -f $SED_MK ] ; then
  echo "@@Cannnot execute, because $SED_MK not exist"
  exit 1
fi

if [ -z $1 ] ; then
  echo "Options (required)"
  echo "   -c  : convert configure scripts using $SED_CONF\n"
  echo "   -s  : convert scripts except configure\n"
  echo "   -m  : convert Makefile.in using $SED_MK\n"
  echo "   -mi : replace mkinstalldir with OS/2 version"
  echo "   -all: execute all steps above"
  echo "   -mk : convert *.mk (needed for web2c) using $SED_MK2\n"
  echo "   -clean : clean temporary files"
  exit 0
fi

if [ ! -f CHMOD_DONE.tmp ] ; then
	chmod +rw -R '*'
	touch CHMOD_DONE.tmp
fi

case "$1" in 
	-s)
		ch_script
		;;

	-c) 
		ch_config
		;;
	-m) 
		ch_makefile
		ch_po_makefile
		;;
	-mi) 
		mkdirs
		;;
	-all)
		ch_config
		ch_script
		ch_makefile
		ch_po_makefile
		mkdirs
		;;
	-mk) 
		web2c_mk
		web2c_make
		;;
	-clean)
	  find . -name '*.tmp' -o -name '*.orig' | xargs rm
	  ;;
	*) echo Unrecognized option ;;
esac




exit 0


